/*
 * PeriodicEventSourceImpl.java
 *
 * Created on January 9, 2006, 11:50 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package sensor;

import java.util.Timer;
//import javax.microedition.io.file.IllegalModeException;

public abstract class PeriodicEventSourceImpl implements PeriodicEventSource {
    long intervalMillis = -1;
    boolean polling;
    Timer timer;
    
    class Poll extends java.util.TimerTask {
        public void run() {
            fireNewEvent();
        }
    }
    
    /** Creates a new instance of PeriodicEventSourceImpl */
    public PeriodicEventSourceImpl() {
    }
    
    public synchronized void setEventInterval(long millis) {
        if (millis < 0) {
            throw new IllegalArgumentException("Interval must be >= 0.");
        }
        
        intervalMillis = millis;
        
        if (timer != null) {
            timer.cancel();
            timer = new Timer();
            timer.schedule(new Poll(), intervalMillis, intervalMillis);
        }
    }
    
    public synchronized void startPolling() {
        if (intervalMillis < 0) {
            throw new IllegalArgumentException("Interval not set.");
        }
        if (timer != null) {
            throw new IllegalStateException("Already polling.");
        }
        
        timer = new Timer();
        timer.schedule(new Poll(), intervalMillis, intervalMillis);
    }
    
    public synchronized void stopPolling() {
        if (timer != null) {
            timer.cancel();
            timer = null;
        }
    }
    
    protected abstract void fireNewEvent();
    public abstract void stop();
}
