/*
 * RaeTest.java
 *
 * Created on January 3, 2006, 6:07 PM
 */

package sensor.raeSystems.multiRAEPlus;

import java.io.IOException;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.io.*;
import java.io.InputStream;
import java.io.OutputStream;

public class RaeTest extends MIDlet {
    private boolean isPaused;
    
    /** Creates a new instance of RaeTest */
    public RaeTest() {
        CommConnection commConn = null;
        InputStream is = null;
        OutputStream os = null;
        
        initialize();
        try {
            commConn = (CommConnection)Connector.open("comm:"
                    + "0"
                    + ";baudrate=9600;bitsperchar=8;stopbits=1;parity=none");
            is = commConn.openInputStream();
            os = commConn.openOutputStream();
            MultiRAEPlus rae = new MultiRAEPlus(is, os);
            
            try {
                Thread.currentThread().sleep(1000);
            } catch (InterruptedException e) {}
            
            test(rae);
        } catch (java.io.IOException e) {
            e.printStackTrace();
        } finally {
            try {
                if (is != null) {
                    is.close();
                }
                if (os != null) {
                    os.close();
                }
                if (commConn != null) {
                    commConn.close();
                }
            } catch (Exception e) {}
            
            exitMIDlet();
        }
        
    }
    
    public void test(MultiRAEPlus m) throws IOException {
        System.out.println("Powered: " + m.isPowerOn());
//        m.setPowerOn(true);
        System.out.println("Firmware version: " + m.getFirmwareVersion());
        System.out.println("Serial number: " + m.getSerialNumber());
        System.out.println("Model number: " + m.getModelNumber());
        String[] names = m.getSensorNames();
        System.out.print("Sensors: ");
        for (int i=0; i < names.length; i++) {
            System.out.print(names[i] + " ");
        }
        System.out.println();
        double[] readings = m.getInstantGasLevels();
        System.out.print("Reading: ");
        for (int i=0; i < readings.length; i++) {
            System.out.print(readings[i] + " ");
        }
        System.out.println("\n");
        
        System.out.println(m);
        System.out.println("Calculated reading:");
        CalculatedReading[] calculatedReadings = m.getCalculatedReadings();
        for (int i=0; i < calculatedReadings.length; i++) {
            System.out.print(calculatedReadings[i]);
        }
        System.out.println("\nAlarm limits:");
        calculatedReadings = m.getAlarmLimits();
        for (int i=0; i < calculatedReadings.length; i++) {
            System.out.print(calculatedReadings[i]);
        }        
        m.setPowerOn(false);
    }
//GEN-LINE:MVDFields
    
    /** This method initializes UI of the application.//GEN-BEGIN:MVDMethods
     */
    private void initialize() {
    }//GEN-END:MVDMethods
    
    /**
     * This method should return an instance of the display.
     */
    public Display getDisplay() {//GEN-FIRST:MVDGetDisplay
        return Display.getDisplay(this);
    }//GEN-LAST:MVDGetDisplay
    
    /**
     * This method should exit the midlet.
     */
    public void exitMIDlet() {//GEN-FIRST:MVDExitMidlet
        getDisplay().setCurrent(null);
        destroyApp(true);
        notifyDestroyed();
    }//GEN-LAST:MVDExitMidlet
    
    public boolean isPaused() {
        return isPaused;
    }
    
    public void startApp() {
        isPaused = false;
    }
    
    
    public void pauseApp() {
        isPaused = true;
    }
    
    public void destroyApp(boolean unconditional) {
    }
    
}
